# encoding: utf-8

import es, gamethread, playerlib, popuplib

# On ajoute quelques infos à afficher lorsqu'un utilisateur tape 'es_load' dans la console
info = es.AddonInfo()
info.name = 'votebotf' # nom du script
info.version = '3.0.0' # version
info.author = 'Fantole' # auteur
info.url = 'http://mattie.info/forums/' # lien où le script peut être trouvé
info.description = 'Effectuer des votes sur les BOT' # description courte
info.tags = 'fantole,vote,bot,vote bot,kick bot' # mots clés

def load():
    global votebotf_sound
    global votebotf_annonce
    global votebotf_tempsvote
    global votebotf_derseconde
    global voteur
    global vote
    global vote_oui
    global vote_non
    global no_vote
    
    es.ServerVar('votebotf_version', info.version, 'Version du script votebotf').makepublic()

    votebotf_sound = es.ServerVar('votebotf_sound', 1, "votebotf : Sons, 0 = Desactiver, 1 = Activer")
    votebotf_annonce = es.ServerVar('votebotf_annonce', 1, "votebotf : Annonce Textuel, 0 = Desactiver, 1 = Activer")
    votebotf_tempsvote = es.ServerVar('votebotf_tempsvote', 15, "votebotf : Duree en secondes d'un vote")
    votebotf_derseconde = int(votebotf_tempsvote) - 5

    voteur = []
    vote = ""
    vote_oui = 0
    vote_non = 0
    no_vote = 0
    
    
    es.mexec('../addons/eventscripts/votebotf/cfg/config_script.cfg')
    es.mexec('../addons/eventscripts/votebotf/cfg/bot_script.cfg')

    menu_accueil()
    menu_accueil2()
    menu_kick()
    menu_slay()
    menu_freeze()
    menu_demande()

def unload():
    popuplib.unsendname("accueil", playerlib.getUseridList("#all"))
    popuplib.delete("accueil")
    popuplib.unsendname("kick", playerlib.getUseridList("#all"))
    popuplib.delete("kick")
    popuplib.unsendname("slay", playerlib.getUseridList("#all"))
    popuplib.delete("slay")
    popuplib.unsendname("freeze", playerlib.getUseridList("#all"))
    popuplib.delete("freeze")
    popuplib.unsendname("accueil2", playerlib.getUseridList("#all"))
    popuplib.delete("accueil2")
    popuplib.unsendname("demande", playerlib.getUseridList("#all"))
    popuplib.delete("demande")
    gamethread.cancelDelayed('der_seconde')
    gamethread.cancelDelayed('fin_vote')

def es_ma_start(event_var):
    es.server.cmd('est_Adddownload sound/votebotf/temps.wav')

def player_team(event_var):
    if int(es.ServerVar('bot_quota')) != 0:
        es.tell(event_var['userid'], '#multi', '#lightgreen[Vote BOT]#green Taper #default!votebot #green pour lancer un vote sur les BOT')

def denied(userid):
    es.server.cmd('es_xplaysound %s buttons/button11.wav 1.0' % userid)

def menu_accueil():
    menu_accueil = popuplib.create("accueil")
    menu_accueil.addline("*~ Vote Bot [Accueil] ~*")
    menu_accueil.addline(" ")

    menu_accueil.addline("1] Kick BOT")
    menu_accueil.addline("2] Slay BOT")
    menu_accueil.addline("3] Freeze BOT")
    menu_accueil.addline("4] Credit")
    menu_accueil.addline("0] Quitter")

    menu_accueil.menuselect = choix_accueil

def menu_accueil2():
    menu_accueil2 = popuplib.create("accueil2")
    menu_accueil2.addline("*~ Vote Bot [Accueil] ~*")
    menu_accueil2.addline(" ")

    menu_accueil2.addline("1] Remettre les BOT")
    menu_accueil2.addline("2] Credit")
    menu_accueil2.addline("0] Quitter")

    menu_accueil2.menuselect = choix_accueil2

def choix_accueil(userid, choix, popupid):
    if choix == 1:
        if int(votebotf_sound) == 1:
            choix_valide(userid)
        # POP UP KICK BOT
        popuplib.send("kick", int(userid))
        
    if choix == 2:
        if int(votebotf_sound) == 1:
            choix_valide(userid)
        # POP UP SLAY BOT
        popuplib.send("slay", int(userid))
            
    if choix == 3:
        if int(votebotf_sound) == 1:
            choix_valide(userid)
        #POP UP FREEZE
        popuplib.send("freeze", int(userid))
            
    if choix == 4:
        if int(votebotf_sound) == 1:
            choix_valide(userid)
        #POP UP CREDIT
        popuplib.send("credit", int(userid))

    if choix == 10:
        close_windows(userid,popupid)

def choix_accueil2(userid, choix, popupid):
    if choix == 1:
        vote = "ajout"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # REMETTRE LES BOT
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kick",str(vote)))

    if choix == 2:
        if int(votebotf_sound) == 1:
            choix_valide(userid)
        # POP UP CREDIT
        popuplib.send("credit", int(userid))

    if choix == 10:
        close_windows(userid,popupid)

def menu_kick():
    menu_kick = popuplib.create("kick")
    menu_kick.addline("*~ Vote Bot [Kick] ~*")
    menu_kick.addline(" ")
    menu_kick.addline("1] Tous")
    menu_kick.addline("2] CT")
    menu_kick.addline("3] T")
    menu_kick.addline("0] Quitter")
    menu_kick.submenu(4, "kick")
    menu_kick.submenu(5, "kick")
    menu_kick.submenu(6, "kick")
    menu_kick.submenu(7, "kick")
    menu_kick.submenu(8, "kick")
    menu_kick.submenu(9, "kick")
    menu_kick.timeout("view", int(votebotf_tempsvote))
    menu_kick.menuselect = choix_kick

def choix_kick(userid, choix, popupid):
    if choix == 1:
        vote = "kick"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Kicker tout les BOT
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kick",str(vote)))
            
    if choix == 2:
        vote = "kick"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Kicker les BOT CT
        #popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kick ct",str(vote)))
            
    if choix == 3:
        vote = "kick"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Kicker les BOT T
        #popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kick t",str(vote)))

    if choix == 10:
        close_windows(userid,popupid)

def menu_demande():
    menu_demande = popuplib.create("demande")
    menu_demande.addline("*~ Vote Bot [%s] ~*" % vote)
    menu_demande.addline(" ")
    menu_demande.addline("1] Oui")
    menu_demande.addline("2] Non")
    menu_demande.addline("3] Je ne vote pas")
    menu_demande.submenu(4, "demande")
    menu_demande.submenu(5, "demande")
    menu_demande.submenu(6, "demande")
    menu_demande.submenu(7, "demande")
    menu_demande.submenu(8, "demande")
    menu_demande.submenu(9, "demande")
    menu_demande.submenu(10, "demande")
    menu_demande.timeout("view", int(votebotf_tempsvote))
    menu_demande.menuselect = choix_demande

def choix_demande(userid, choix, popupid):
    if choix == 1:
        global vote_oui
        # Le joueur dit oui au vote
        voteur.append(es.getplayersteamid(userid))
        vote_oui = int(vote_oui) +1
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            
    if choix == 2:
        global vote_non
        vote_non = int(vote_non) +1
        # Le joueur dit non au vote
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            
    if choix == 3:
        global no_vote
        # Le joueur ne vote pas
        no_vote = int(no_vote) +1
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)

    if choix == 10:
        close_windows(userid,popupid)

def test():
    es.msg('#multi', '#green test')

def menu_slay():
    es.msg('#multi', '#green lol')
    menu_slay = popuplib.create("slay")
    menu_slay.addline("*~ Vote Bot [Slay] ~*")
    menu_slay.addline(" ")
    menu_slay.addline("1] Tous")
    menu_slay.addline("2] CT")
    menu_slay.addline("3] T")
    menu_slay.addline("0] Quitter")
    menu_slay.submenu(4, "slay")
    menu_slay.submenu(5, "slay")
    menu_slay.submenu(6, "slay")
    menu_slay.submenu(7, "slay")
    menu_slay.submenu(8, "slay")
    menu_slay.submenu(9, "slay")
    menu_slay.timeout("view", int(votebotf_tempsvote))
    menu_slay.menuselect = choix_slay


def choix_slay(userid, choix, popupid):
    if choix == 1:
        vote = "slay"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Slayer tout les BOT
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kill",str(vote)))
           
    if choix == 2:
        vote = "slay"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Slayer les BOT CT
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kill ct",str(vote)))
            
    if choix == 3:
        vote = "slay"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Slayer les BOT T
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("bot_kill t",str(vote)))

    if choix == 10:
        close_windows(userid,popupid)

def menu_freeze():
    menu_freeze = popuplib.create("freeze")
    menu_freeze.addline("*~ Vote Bot [Freeze] ~*")
    menu_freeze.addline(" ")
    menu_freeze.addline("1] Tous")
    menu_freeze.addline("2] CT")
    menu_freeze.addline("3] T")
    menu_freeze.addline("0] Quitter")
    menu_freeze.submenu(4, "freeze")
    menu_freeze.submenu(5, "freeze")
    menu_freeze.submenu(6, "freeze")
    menu_freeze.submenu(7, "freeze")
    menu_freeze.submenu(8, "freeze")
    menu_freeze.submenu(9, "freeze")
    menu_freeze.timeout("view", int(votebotf_tempsvote))
    menu_freeze.menuselect = choix_freeze

def choix_freeze(userid, choix, popupid):
    if choix == 1:
        vote = "freeze"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Freezer tout les BOT
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("#b",str(vote)))
            
    if choix == 2:
        vote = "freeze"
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        voteur.append(es.getplayersteamid(userid))
        # Freezer les BOT CT
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("#b,#c",str(vote)))
            
    if choix == 3:
        vote = "freeze"
        voteur.append(es.getplayersteamid(userid))
        if int(votebotf_sound) == 1:
            choix_valide(userid)
            es.server.cmd('est_PlayPlayer #a buttons/weapon_confirm.wav 1.0')
            gamethread.delayedname(int(votebotf_derseconde), 'der_seconde', der_seconde)
        # Freezer les BOT T
        # popuplib.send("demande", int(userid))
        popuplib.send("demande", playerlib.getUseridList("#all"))
        gamethread.delayedname(int(votebotf_tempsvote), 'fin_vote', fin_vote, ("#b,#t",str(vote)))

    if choix == 10:
        close_windows(userid,popupid)

def menu_credit():
    menu_credit = popuplib.create("credit")
    menu_credit.addline("*~ Vote Bot [Credit] ~*")
    menu_credit.addline(" ")
    menu_credit.addline("Script : votebotf")
    menu_credit.addline("Version : 3.0.0")
    menu_credit.addline("Auteur : Fantole")
    menu_credit.addline("0] Quitter")
    menu_credit.submenu(1, "credit")
    menu_credit.submenu(2, "credit")
    menu_credit.submenu(3, "credit")
    menu_credit.submenu(4, "credit")
    menu_credit.submenu(5, "credit")
    menu_credit.submenu(6, "credit")
    menu_credit.submenu(7, "credit")
    menu_credit.submenu(8, "credit")
    menu_credit.submenu(9, "credit")
    menu_credit.timeout("view", int(votebotf_tempsvote))
    
def choix_valide(userid):
    es.server.cmd('es_xplaysound %s weapons/zoom.wav 1.0' % int(userid))

def close_windows(userid,popupid):
    if int(votebotf_sound) == 1:
        es.server.cmd('es_xplaysound %s weapons/debris1.wav 1.0' % userid)
    popuplib.close(popupid, userid)

def player_say(event_var):
    userid = event_var['userid']
    joueur = playerlib.getPlayer(userid)
    steamid = joueur.attributes["steamid"]
    
    if event_var['text'] == "!votebot":
        if str(steamid) in voteur:
            es.tell(userid, '#multi', '#lightgreen[Vote BOT]#green Vous avez déjà voté')
            denied(userid)

        else:
            if int(es.ServerVar('bot_quota')) != 0:
                choix_valide(userid)
                popuplib.send("accueil", int(userid))

            else:
                choix_valide(userid)
                popuplib.send("accueil2", int(userid))

def fin_vote(commande,vote):
    global vote_oui
    global vote_non
    global no_vote
    
    if str(vote) == "kick":
        if int(vote_oui) > int(vote_non):
            es.server.queuecmd(commande)
            if int(votebotf_annonce) == 1:
                es.msg('#multi', '#lightgreen[Kick BOT]#green Le OUI l\'emporte avec %s voix contre %s voix pour le OUI {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))

        if int(vote_oui) < int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Kick BOT]#green Le NON l\'emporte avec %s voix contre %s voix pour le Oui {%s personne(s) n\'ont pas votés}' % (int(vote_non), int(vote_oui), int(no_vote)))

        if int(vote_oui) == int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Kick BOT]#green Vote NUL %s voix OUI et %s voix NON {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))

    #popuplib.unsendname("kick", playerlib.getUseridList("#all"))

    if str(vote) == "slay":
        if int(vote_oui) > int(vote_non):
            es.server.queuecmd(commande)
            if int(votebotf_annonce) == 1:
                es.msg('#multi', '#lightgreen[Slay BOT]#green Le OUI l\'emporte avec %s voix contre %s voix pour le OUI {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))

        if int(vote_oui) < int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Slay BOT]#green Le NON l\'emporte avec %s voix contre %s voix pour le Oui {%s personne(s) n\'ont pas votés}' % (int(vote_non), int(vote_oui), int(no_vote)))

        if int(vote_oui) == int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Slay BOT]#green Vote NUL %s voix OUI et %s voix NON {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))
    #popuplib.unsendname("slay", playerlib.getUseridList("#all"))    

    if str(vote) == "freeze":
        if int(vote_oui) > int(vote_non):
            es.server.queuecmd('est_Freeze %s 1' % str(commande))
            if int(votebotf_annonce) == 1:
                es.msg('#multi', '#lightgreen[Freeze BOT]#green Le OUI l\'emporte avec %s voix contre %s voix pour le OUI {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))

        if int(vote_oui) < int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Freeze BOT]#green Le NON l\'emporte avec %s voix contre %s voix pour le Oui {%s personne(s) n\'ont pas votés}' % (int(vote_non), int(vote_oui), int(no_vote)))

        if int(vote_oui) == int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Freeze BOT]#green Vote NUL %s voix OUI et %s voix NON {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))
    #popuplib.unsendname("freeze", playerlib.getUseridList("#all"))        
    
    if str(vote) == "ajout":
        if int(vote_oui) > int(vote_non):
            es.mexec('../addons/eventscripts/votebotf/cfg/bot_script.cfg')
            if int(votebotf_annonce) == 1:
                es.msg('#multi', '#lightgreen[Ajout BOT]#green Le OUI l\'emporte avec %s voix contre %s voix pour le OUI {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))

        if int(vote_oui) < int(vote_non) and int(votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Ajout BOT]#green Le NON l\'emporte avec %s voix contre %s voix pour le Oui {%s personne(s) n\'ont pas votés}' % (int(vote_non), int(vote_oui), int(no_vote)))

        if int(vote_oui) == int(vote_non) and int (votebotf_annonce) == 1:
            es.msg('#multi', '#lightgreen[Ajout BOT]#green Vote NUL %s voix OUI et %s voix NON {%s personne(s) n\'ont pas votés}' % (int(vote_oui), int(vote_non), int(no_vote)))
        
    vote = ""
    voteur = []
    no_vote = 0
    vote_oui = 0
    vote_non = 0
    #popuplib.unsendname("demande", playerlib.getUseridList("#all"))
    #popuplib.unsendname("accueil", playerlib.getUseridList("#all"))
    #popuplib.unsendname("accueil2", playerlib.getUseridList("#all"))
    popuplib.unsendname("demande", playerlib.getUseridList("#all"))
    if int(votebotf_sound) == 1:
        es.server.cmd('est_PlayPlayer #a ambient/office/coinslot1.wav 1.0' % playerlib.getUseridList("#all"))

def der_seconde():
    es.server.cmd('est_PlayPlayer #a votebot/temps.wav 1.0')
